#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=..\FramaKiosk\PortableKioskCode\FramaKiosk.ico
#AutoIt3Wrapper_UseUpx=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.2.10.0
 Author:         pyg@framasoft.net

 Script Function:
	Lit un fichier CSV et le transforme en fichiers .html pour le Kiosk

#ce ----------------------------------------------------------------------------
#include <file.au3>
#include <Array.au3>

$create_lch=true
$file = FileOpen("FramaKioskContent.csv", 128)
$destination_file=""
$creation_path_prepend=_PathFull(@ScriptDir & "..\..\")

$html_prepend='<script type="text/javascript">' & @CRLF
$html_prepend&="$(function() {" & @CRLF
$html_prepend&="	$('.applications *').tooltip({" & @CRLF
$html_prepend&="	track: true," & @CRLF
$html_prepend&="	delay: 700,	" & @CRLF
$html_prepend&='	showBody: " - ",' & @CRLF
$html_prepend&="	showURL: false" & @CRLF
$html_prepend&="	});" & @CRLF
$html_prepend&="});" & @CRLF
$html_prepend&="</script>" & @CRLF
$html_prepend&='<div id="apps" class="applications">' & @CRLF

$html_append='</div>' & @CRLF

; Check if file opened for reading OK
If $file = -1 Then
    MsgBox(0, "Error", "Unable to open file.")
    Exit
EndIf

; Read in lines of text until the EOF is reached
$n=2 ; on passera la premire ligne
$i=1
$content = $html_prepend


While 1
    $line = FileReadLine($file,$n)
    If @error = -1 Then ExitLoop

	If (IsString($line)) Then

		$data = StringSplit($line, ";")
		;_ArrayDisplay($data)
		$data = RemoveQuotes($data)

			$category=		$data[1]
			$subcategory=	$data[2]
			$name=			$data[3]
			$priority=		$data[4]
			$clean_name=	HTMLProtect($data[5])
			$usage=			HTMLProtect($data[6])
			$short_desc=	HTMLProtect($data[7])
			$long_desc=		HTMLProtect($data[8])
			$version=		$data[9]
			$dir=			$data[10]
			$app_path=		$data[11]
			$app_filename=	$data[12]
			$lch_path=		$data[13]
			$lch_filename=	$data[14]
			$lch_parameters=$data[15]
			$img_path=		$data[16]
			$img_filename=	$data[17]

			If $app_path='' Then
				$app_path='..\..\..\' & $dir & "\" & $name & "\"
			EndIf
			If $app_filename='' Then
				$app_filename=$name & ".exe"
			EndIf
			If $lch_path='' Then
				$lch_path='lch/' & $dir & "/"
			EndIf
			If $lch_filename='' Then
				$lch_filename=$name & ".lch"
			EndIf
			If $img_path='' Then
				$img_path=$app_path & "App/AppInfo/"
			EndIf
			If $img_filename='' Then
				$img_filename="appicon_64.png"
			EndIf


		$file_to_create= $creation_path_prepend & StringConvert($data[1]) & ".html"

		;si la catgorie en cours correspond au fichier qui est ouvert
		If $file_to_create=$destination_file Then
			;alors on rempli les donnes
			$content &= csv2html($data)
			$n=$n+1
			$i=$i+1
		Else ;sinon
			If $destination_file='' Then ; cas particulier : le fichier en cours n'est pas ouvert
				;MsgBox(0, "Catgorie en cours:", $file_to_create)
				$current = FileOpen($file_to_create, 138) ; which is similar to 2 + 8 + 128 (erase + create dir + UTF8)
				$content &= csv2html($data)
				$n=$n+1
				$i=$i+1
				$destination_file=$file_to_create
			Else
				$content&=$html_append
				FileWriteLine($current, $content); on crit les donnes dans le fichier ouvert
				FileClose($current); on ferme le fichier ouvert
				$content=$html_prepend; on remet le contenu  0
				; on rouvre un nouveau fichier
				$current = FileOpen($file_to_create, 138) ; which is similar to 2 + 8 + 128 (erase + create dir + UTF8)
				$destination_file=$file_to_create
			EndIf
		EndIf ;fin de la cration des fichiers .html

		;fichiers .lch
		If $create_lch Then
			$t = CreateLch()
		EndIf
		;fin fichiers .lch

	EndIf
Wend
FileClose($file)
$content&=$html_append
FileWriteLine($current, $content); on crit les donnes dans le fichier ouvert
FileClose($current); on ferme le fichier ouvert


If $file = -1 Then
    MsgBox(0, "Error", "Unable to open file.")
    Exit
EndIf

FileClose($file)


Func csv2html($data)



#CS ------ ;on construit le contenu
   	<div class="application">
		<div class="icone"><a href="lch\apps\firefox.lch" title="Firefox - Description du logiciel. Cette description peut tre un peu plus longue"><img alt="portableOpenOffice.org" src="img/apps/PortableFirefox.png" /></a></div>
		<div class="description">Navigateur web</div>
	</div>
#CE ------

	If $name="-SEPARATOR-" Then
		$out = '	<div class="separator">' & $clean_name & '</div>' & @CRLF & @CRLF

	Else
		$out = '	<div class="application">' & @CRLF
		$out &= '		<div class="icone">'
		$out &= '<a href="' & Win2Nux($lch_path & $lch_filename) & '" '
		$out &= 'title="' & $clean_name & " - " & $short_desc & '">'
		$out &= '<img alt="' & $clean_name & '" src="' & Win2Nux($img_path & $img_filename) & '" /></a></div>' & @CRLF
		$out &= '		<div class="description">' & $usage & '</div>' & @CRLF
		$out &= '	</div>' & @CRLF & @CRLF

	EndIf


	;MsgBox(0, "Line read:", $out)
	Return $out
EndFunc

Func StringConvert($d)
	$d = StringRegExpReplace($d, "[]","e")
	$d = StringRegExpReplace($d, "[]","a")
	$d = StringRegExpReplace($d, "[]","c")
	$d = StringRegExpReplace($d, "[]","u")
	$d = StringRegExpReplace($d, "[ ]","_")
	$d = StringLower ($d) ;
	Return $d
EndFunc


Func HTMLProtect($string)
	;$string = StringReplace($string, "'", "\'")
	$string = StringReplace($string, '"', '\"')
	Return $string
EndFunc

Func RemoveQuotes($data)
	$j = UBound($data)-1
	For $i = 1 to $j
		if IsString($data[$i]) Then
			$data[$i]=StringTrimLeft($data[$i],1)
			$data[$i]=StringTrimRight($data[$i],1)
		Else
			$data[$i]=$data[$i]
		EndIf
	Next
	Return $data
EndFunc

Func CreateLch()
	 $lch_path = StringReplace($lch_path, '/', '\')

	If $name="-SEPARATOR-" Then
		Return false
	EndIf

	Dim $lch_to_create, $lch_content

	$lch_content = "[Launch] " & @CRLF
	$lch_content &= "ExecuteFile=FramaRoot\Apps\" & $name & "\" & $app_filename & @CRLF
	$lch_content &= "ExecuteDirectory=FramaRoot\Apps\" & $name &"\" & @CRLF
	$lch_content &= "ExecuteParameters=" & $lch_parameters & @CRLF

	$lch_to_create=$creation_path_prepend & $lch_path & $lch_filename
	;MsgBox(0, "Error", $lch_to_create)
	$lchfile = FileOpen($lch_to_create, 10) ; which is similar to 2 + 8 (erase + create dir )
	If $lchfile = -1 Then
		MsgBox(0, "Error", "Unable to open file " & $lch_to_create)
		Return false
	EndIf
	FileWriteLine($lchfile, $lch_content); on crit les donnes dans le fichier ouvert
	FileClose($lchfile); on ferme le fichier ouvert

	Return true
EndFunc

Func Win2Nux($data)
	Return StringReplace($data, '\', '/')
EndFunc

Func Nux2Win($data)
	Return StringReplace($data, '/', '\')
EndFunc
