#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=..\FramaKiosk\PortableKioskCode\FramaKiosk.ico
#AutoIt3Wrapper_UseUpx=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.2.10.0
 Author:         pyg@framasoft.net

 Script Function:
	Lit un fichier CSV et le transforme en fichiers .html pour Asuite

#ce ----------------------------------------------------------------------------
#include <file.au3>
#include <Array.au3>

$create_lch=true
$file = FileOpen("FramaKioskContent.csv", 128)
$destination_file=""
$creation_path_prepend=_PathFull(@ScriptDir & "..\..\")

$content=''


; Check if file opened for reading OK
If $file = -1 Then
    MsgBox(0, "Error", "Unable to open file.")
    Exit
EndIf

; Read in lines of text until the EOF is reached
$n=2 ; on passera la premire ligne
$i=1

$asuitefile = FileOpen("PartialAsuite.xml", 138)
While 1
    $line = FileReadLine($file,$n)
    If @error = -1 Then ExitLoop

	If (IsString($line)) Then

		$data = StringSplit($line, ";")
		;_ArrayDisplay($data)
		$data = RemoveQuotes($data)

			$category=		$data[1]
			$subcategory=	$data[2]
			$name=			$data[3]
			$priority=		$data[4]
			$clean_name=	HTMLProtect($data[5])
			$usage=			HTMLProtect($data[6])
			$short_desc=	HTMLProtect($data[7])
			$long_desc=		HTMLProtect($data[8])
			$version=		$data[9]
			$dir=			$data[10]
			$app_path=		$data[11]
			$app_filename=	$data[12]
			$lch_path=		$data[13]
			$lch_filename=	$data[14]
			$lch_parameters=$data[15]
			$img_path=		$data[16]
			$img_filename=	$data[17]

			If $app_path='' Then
				$app_path='..\..\' & $dir & "\" & $name & "\"
			EndIf
			If $app_filename='' Then
				$app_filename=$name & ".exe"
			EndIf
			If $lch_path='' Then
				$lch_path='lch/' & $dir & "/"
			EndIf
			If $lch_filename='' Then
				$lch_filename=$name & ".lch"
			EndIf
			If $img_path='' Then
				$img_path=$app_path & "App/AppInfo/"
			EndIf
			If $img_filename='' Then
				$img_filename="appicon_64.png"
			EndIf

			$content &= csv2html($data)
			$n=$n+1
			$i=$i+1

	EndIf
Wend
FileWriteLine($asuitefile, $content); on crit les donnes dans le fichier ouvert

FileClose($asuitefile)
FileClose($file)

If $file = -1 Then
    MsgBox(0, "Error", "Unable to open file.")
    Exit
EndIf

FileClose($file)


Func csv2html($data)



#cs
    <Category name="Internet">
      <Software name="FirefoxPortable">
        <PathCache>cache\11.ico</PathCache>
        <PathExe>$Asuite\..\..\Apps\FramafoxPortable\FramafoxPortable.exe</PathExe>
        <Version>3.5.5</Version>
        <WebSite>http://framakey.org/Portables/FramafoxPortable</WebSite>
        <Description>Mozilla Firefox est le projet de navigateur indpendant de la fondation Mozilla.[br][br]Outre le fait de changer souvent de nom (Phoenix est devenu Firebird puis aujourdhui Firefox, ou plus exactement Mozilla Firefox), il prsente la particularit dtre, comment vous dire super, extra, gnial ![br][br]Le modle lger  tlcharger, et lger  installer. Laspect est fort agrable (on peut de plus changer de look via les thmes). Au passage signalons que le logiciel importe automatiquement les signets dInternet Explorer. </Description>
      </Software>
#ce

	If $name="-SEPARATOR-" Then
		$out = ''

	Else
		$out = '	<Software name="'&$clean_name&'">' & @CRLF
		$out &= '		  <PathCache></PathCache>' & @CRLF
		$out &= '		  <PathExe>$Asuite\' & Nux2win($app_path & $app_filename) & '</PathExe>' & @CRLF
		$out &= '		  <Version>'&$version&'</Version>' & @CRLF
		$out &= '		  <WebSite>http://framakey.org/Portables/'&$name&'</WebSite>' & @CRLF
		$out &= '		  <Description>'&$short_desc &'</Description>' & @CRLF
		$out &= '	</Software>' & @CRLF
	EndIf


	;MsgBox(0, "Line read:", $out)
	Return $out
EndFunc

Func StringConvert($d)
	$d = StringRegExpReplace($d, "[]","e")
	$d = StringRegExpReplace($d, "[]","a")
	$d = StringRegExpReplace($d, "[]","c")
	$d = StringRegExpReplace($d, "[]","u")
	$d = StringRegExpReplace($d, "[ ]","_")
	$d = StringLower ($d) ;
	Return $d
EndFunc


Func HTMLProtect($string)
	;$string = StringReplace($string, "'", "\'")
	$string = StringReplace($string, '"', '\"')
	Return $string
EndFunc

Func RemoveQuotes($data)
	$j = UBound($data)-1
	For $i = 1 to $j
		if IsString($data[$i]) Then
			$data[$i]=StringTrimLeft($data[$i],1)
			$data[$i]=StringTrimRight($data[$i],1)
		Else
			$data[$i]=$data[$i]
		EndIf
	Next
	Return $data
EndFunc

Func Win2Nux($data)
	Return StringReplace($data, '\', '/')
EndFunc

Func Nux2Win($data)
	Return StringReplace($data, '/', '\')
EndFunc
