; ----------------------------------------------------
; Framakey Launcher
; ----------------------------------------------------
; Par fat115
; License : GNU/GPL v2
; Ce script permet de crer le lanceur d'applications
; pour le FramaKiosk.
; Compiler: NSIS (http://www.nullsoft.com).
; $id=Launch.nsi $date=2010-04-28
; ----------------------------------------------------
;Copyright (C) 2005-2010 Framakey

;Website: http://www.framakey.org

;This software is OSI Certified Open Source Software.
;OSI Certified is a certification mark of the Open Source Initiative.

;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.

;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
;GNU General Public License for more details.

;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA	02110-1301, USA.
; ----------------------------------------------------
; Gnral
; Dfinition variables entte
!define LANG "French"
!define NAME "Launch"
!define FULLNAME "lch Launcher"
!define VER "0.9.5.0"
!define LAUNCHVER "0.2.0.0" ;Version du lanceur
!define PROJECT "Framakey Launcher" ;Nom du projet
!define COMPANY "Framakey.org" ;Nom du groupe dveloppant le projet
!define WEBSITE "http://www.framakey.org"

; Etiquette
Caption "${FULLNAME}"

; Nom de l'excutable
Name "${NAME}"

; Icone
Icon "Launch.ico"
WindowIcon Off

; Nom du fichier  crer
OutFile "${NAME}.exe"

; Options de Compilation
CRCCheck On
SilentInstall Silent
AutoCloseWindow True
RequestExecutionLevel user

; Compression Optimale
SetCompress Auto
SetCompressor /SOLID lzma
SetCompressorDictSize 32
SetDatablockOptimize On

; ----------------------------------------------------
; Liste des includes
;(Standard NSIS)
!include LogicLib.nsh
!include FileFunc.nsh
!include StrFunc.nsh
!include WordFunc.nsh
${StrRep}
${StrLoc}

; Personnalises
!include "LaunchLang_${LANG}.nsh"

; Inclusion langue franaise (ajout de sarkos)
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\${LANG}.nlf"

; ----------------------------------------------------
; Informations de Version

VIProductVersion "${VER}"
VIAddVersionKey ProductName "${FULLNAME}"
VIAddVersionKey FileDescription "${FILEDESCRIPTIONTEXT}"
VIAddVersionKey LegalTrademarks "${LEGALTRADEMARKSTEXT}"
VIAddVersionKey LegalCopyright "${LEGALCOPYRIGHTTEXT}"
VIAddVersionKey Comments "${COMMENTSTEXT}"
VIAddVersionKey CompanyName "${COMPANY}"
VIAddVersionKey OriginalFilename "${NAME}.exe"
VIAddVersionKey FileVersion "${LAUNCHVER}"

; ----------------------------------------------------
; Variables

Var ExecFile
Var ExecDir
Var ExecParam
Var FramakeyPath
Var LauncherName
Var ExecString
Var FileType
Var LauncherDrive
Var KeyDrive
Var ParamIsUrl


; ----------------------------------------------------
; Sections

Section "Main"

; Nom du fichier lch appel avec le chemin complet
${GetParameters} $LauncherName
; On enlve les guillemets qui font planter
${StrRep} $LauncherName $LauncherName '"' ''

; on rcupre les lettres de la cl et du fichier lch
${GetRoot} $EXEDIR $KeyDrive
${GetRoot} $LauncherName $LauncherDrive

; On lit les items du fichier lch
ReadINIStr "$ExecFile" "$LauncherName" "Launch" "ExecuteFile"
ReadINIStr "$ExecDir" "$LauncherName" "Launch" "ExecuteDirectory"
ReadINIStr "$ExecParam" "$LauncherName" "Launch" "ExecuteParameters"

; On rcupre le dossier de base (contenant Framastarter.exe ou start.exe (FK1.x)) avec un loop
StrCpy $R1 "$EXEDIR"
${WordFind} "$R1" "\" "*" $R2
${Do}
	${If} ${FileExists} $R1\FramaStarter.exe
	${OrIf} ${FileExists} $R1\start.exe
		StrCpy $FramakeyPath "$R1"
		${ExitDo}
	${EndIf}
	IntOp $R2 $R2 - 1
	${GetParent} "$R1" $R1
${LoopUntil} $R2 < 0

; si le FramakeyPath est vide, on affiche un avertissement et on quitte
${If} $FramakeyPath == ""
	MessageBox MB_OK|MB_ICONSTOP "${ROOTNOTFOUND}"
	Quit
${EndIf}

; on recherche http: dans les paramtres
${StrLoc} $ParamIsUrl "$ExecParam" "http://" ">"
; si le lch n'est pas sur la cl, on affiche un avertissement et on quitte
${If} $KeyDrive != $LauncherDrive
${AndIf} $ParamIsUrl != "0"
	MessageBox MB_OK|MB_ICONSTOP "${REMOTELCH}"
	Quit
${EndIf}

; On remplace FramaRoot par le chemin
${StrRep} "$ExecFile" "$ExecFile" "FramaRoot" "$FramakeyPath"
${StrRep} "$ExecDir" "$ExecDir" "FramaRoot" "$FramakeyPath"
${StrRep} "$ExecParam" "$ExecParam" "FramaRoot" "$FramakeyPath"

; Cas particulier des scripts VBS
${GetFileExt} $ExecFile $FileType
${If} $FileType == "vbs"
	ExecShell "open" "$ExecFile"
	Quit
${EndIf}

SetOutPath "$ExecDir" 

; on teste l'existence du pogramme  lancer
${IfNot} ${FileExists} "$ExecFile"
	${If} $ParamIsUrl == "0"
		ExecShell "open" "$ExecParam"
		Quit
	${Else}
		MessageBox MB_OK|MB_ICONSTOP `${NOEXEMSG}`
		Quit
	${EndIf}
${EndIf}

; On teste si ExecParam est vide (bug avec SumatraPDF si un paramtre vide est pass : fermeture de l'appli)

${If} $ExecParam == ""
	StrCpy $ExecString '"$ExecFile"'
${Else}
	StrCpy $ExecString '"$ExecFile" "$ExecParam"'
${EndIf}

Exec "$ExecString"


SectionEnd

; -------------------------------------------
; Fin du script