#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Res_Description=Donwload and install VirtualBox portable
#AutoIt3Wrapper_Res_Fileversion=1.0.0.9
#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=y
#AutoIt3Wrapper_Res_LegalCopyright=Pierre-Yves Gosset for Framakey.org
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.2.13.13 (beta)
 Author:         pyg@framasoft.net
 License:		 GNU/GPL V2 & more
 Script Function:
	Download and install Portable VitualBox.

#ce ----------------------------------------------------------------------------



#include <7Zip.au3>
#Include <Array.au3>
#include <GUIComboBox.au3>
#Include <File.au3>
#include <GuiEdit.au3>
#Include <Date.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>

; variables
$script = @ScriptDir
Dim $szDrive, $szDir, $szFName, $szExt
$TestPath = _PathSplit(@ScriptFullPath, $szDrive, $szDir, $szFName, $szExt)
;_ArrayDisplay($TestPath,"Demo _PathSplit()")
$virtualbox_download_url = IniRead(@ScriptDir&"/"&@ScriptName&".ini", "config", "virtualbox_download_url", "http://files.framakey.org/apps/VirtualBox.7z")
$virtualbox_download_file= IniRead(@ScriptDir&"/"&@ScriptName&".ini", "config", "virtualbox_download_file", "VirtualBox.7z")
$miseengarde_text = "Souhaitez vous installer VirtualBox portable pour Windows sur votre cl ?"& @CRLF
$miseengarde_text &= "VirtualBox vous permettra de lancer le systme Ubuntu-Live au sein de Windows."& @CRLF & @CRLF
$miseengarde_text &= "Attention : VirtualBox portable n'est pas un logiciel libre, il est soumis  la licence PUEL (gratuite pour l'ducation et l'valuation du produit)."
$puel_txt=IniRead(@ScriptDir&"/"&@ScriptName&".ini", "config", "puel_txt", "PUEL.txt")





Opt("GUIOnEventMode", 1)
#Region ### START Koda GUI section ### Form=
$Form1 = GUICreate("Installation de VirtualBox Portable", 633, 447, 193, 125)
GUISetOnEvent($GUI_EVENT_CLOSE, "Form1Close")
GUISetOnEvent($GUI_EVENT_MINIMIZE, "Form1Minimize")
GUISetOnEvent($GUI_EVENT_MAXIMIZE, "Form1Maximize")
GUISetOnEvent($GUI_EVENT_RESTORE, "Form1Restore")
$Edit1 = GUICtrlCreateEdit("", 8, 112, 609, 265)
GUICtrlSetData($Edit1, "")
GUICtrlSetOnEvent($Edit1, "Edit1Change")
$titre = GUICtrlCreateLabel("Tlchargement et installation de VirtualBox Portable", 8, 8, 372, 20)
GUICtrlSetFont($titre, 10, 800, 0, "MS Sans Serif")
GUICtrlSetOnEvent($titre, "titreClick")
$BtnNo = GUICtrlCreateButton("Non, merci", 344, 408, 75, 25, 0)
GUICtrlSetOnEvent($BtnNo, "BtnNoClick")
$BtnYes = GUICtrlCreateButton("Oui, j'accepte la licence", 448, 408, 171, 25, 0)
GUICtrlSetOnEvent($BtnYes, "BtnYesClick")
$question = GUICtrlCreateLabel("Voulez-vous tlcharger et installer VirtualBox Portable ?", 24, 392, 327, 17)
GUICtrlSetFont($question, 8, 800, 0, "MS Sans Serif")
GUICtrlSetOnEvent($question, "questionClick")
$miseengarde = GUICtrlCreateLabel($miseengarde_text, 24,40,580,65)
GUICtrlSetOnEvent($miseengarde, "miseengardeClick")
_GUICtrlEdit_AppendText($Edit1, PUEL_License())
_GUICtrlEdit_SetReadOnly($Edit1, True)

; GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###





; prsence de virtualbox  la racine ?
if FileExists($szDrive&"\VirtualBox") Then
	#Region --- CodeWizard generated code Start ---
	;MsgBox features: Title=Yes, Text=Yes, Buttons=OK, Icon=Info
	MsgBox(64,"VirtualBox dj prsent","VirtualBox semble dj install  la racine de votre cl." & @CRLF & @CRLF & "Si vous souhaitez le reinstaller, supprimez le dossier.")
	#EndRegion --- CodeWizard generated code End ---
	Exit
EndIf


; connexion  internet ?
$var = Ping("http://www.framakey.org",250)
If $var Then
	#Region --- CodeWizard generated code Start ---
	;MsgBox features: Title=Yes, Text=Yes, Buttons=OK, Icon=Info
	MsgBox(64,"Pas de connexion  internet","Cette machine n'est pas connecte  Internet, ou refuse que ce programme s'y connecte." & @CRLF & @CRLF & "Vrifiez votre connexion internet ou les paramtres de votre pare-feu.")
	#EndRegion --- CodeWizard generated code End ---
	Exit
EndIf


; prsence du fichier en ligne ?
$size = InetGetSize($virtualbox_download_url)
if @error Then
	#Region --- CodeWizard generated code Start ---
	;MsgBox features: Title=Yes, Text=Yes, Buttons=OK, Icon=Warning
	MsgBox(48,"Fichier non trouv","Le fichier contenant l'archive de VirtualBox n'est pas trouvable, dsol..." & @CRLF)
	#EndRegion --- CodeWizard generated code End ---

	Exit
EndIf

; Affichage boite dialogue + licence
GUISetState(@SW_SHOW,$Form1)

; traitement de la rponse
Func BtnNoClick()
	exit
EndFunc

Func BtnYesClick()

	GUICtrlSetState($BtnNo, $GUI_DISABLE)
	GUICtrlSetState($BtnYes, $GUI_DISABLE)
	$downloadVboxState=DownloadVBox()
	; dzippage
	TrayTip("Dcompression", "Dcompression en cours"  , 10, 16)
	$retResult = _7ZIPExtractEx($Form1, $virtualbox_download_file, $szDrive, 0)

	; suppresion du .zip
	if @error Then
		MsgBox(64,"Erreur","Problme lors de la dcompression :(")
		TrayTip("", "",3)
	Else 
		FileDelete($virtualbox_download_file)
	EndIf

	; fin
	#Region --- CodeWizard generated code Start ---
	;MsgBox features: Title=Yes, Text=Yes, Buttons=OK, Icon=Info
	MsgBox(64,"Termin","VirtualBox est maintenant install dans "&$szDrive&"/Virtualbox ! :)")
	#EndRegion --- CodeWizard generated code End ---
	exit		
	
EndFunc





; ======== Fonctions ==========

While 1
	Sleep(100)
WEnd

; tlchargement+vrification
Func DownloadVBox() 
	
	If FileExists($virtualbox_download_file) Then
		If Not IsDeclared("iMsgBoxAnswer") Then Local $iMsgBoxAnswer
		$iMsgBoxAnswer = MsgBox(36,"Fichier existant","Le fichier a tlcharger est dj prsent." & @CRLF & @CRLF & "Cliquez sur 'oui' pour le conserver et poursuivre avec ce fichier." & @CRLF & "Cliquez sur 'non' pour l'effacer et le tlcharger  nouveau.")
		Select
			Case $iMsgBoxAnswer = 6 ;Yes
				Return
			Case $iMsgBoxAnswer = 7 ;No
				FileDelete($virtualbox_download_file)
		EndSelect
	EndIf
	
	InetGet($virtualbox_download_url, $virtualbox_download_file, 1,1)

	While @InetGetActive
	  TrayTip("Downloading", "Tlchargement en cours..."&@CRLF &" "&  Round((@InetGetBytesRead/$size)*100, 2) & "%"  , 10, 16)
	  Sleep(250)
	Wend
	
	Return
	
EndFunc



Func PUEL_License()
	$file = FileOpen($puel_txt, 0)
	$text =""
	; Check if file opened for reading OK
	If $file = -1 Then
		MsgBox(0, $puel_txt, "Impossible d'ouvrir le fichier de licence")
		Exit
	EndIf

	While 1
		$chars = FileRead($file)
		If @error = -1 Then ExitLoop
		$text &=$chars 
	Wend

	FileClose($file)
	Return $text
EndFunc


Func Edit1Change()

EndFunc
Func Form1Close()
	exit
EndFunc
Func Form1Maximize()

EndFunc
Func Form1Minimize()

EndFunc
Func Form1Restore()

EndFunc
Func miseengardeClick()

EndFunc
Func questionClick()

EndFunc
Func titreClick()

EndFunc