/*
; ----------------------------------------------------
; Framakey Starter : MainScript
; ----------------------------------------------------
; Written by sarkos and Lahire Biette (aka Tuxmouraille)
; License : GPL
; Ce script permet de fabriquer un excutable charg de lancer la Framakey.
; Compiler: NSIS (http://www.nullsoft.com).
; Require plugins: "newadvsplash", "NotifyIcon" and "processwork"
; http://nsis.sourceforge.net/NewAdvSplash_plug-in
; http://nsis.sourceforge.net/NotifyIcon_plug-in
; http://www.esanu.name/programs/NSISKillProcess.html
; $id=FramaStarter.nsi $date=2007-03-09
; ----------------------------------------------------
; Copyright (C) 2005-2007 Framakey Team

; Website: http://www.framakey.org

; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2
; of the License, or (at your option) any later version.

; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
; ----------------------------------------------------
*/
; Gnral
RequestExecutionLevel user
; Dfinition variables entte
  !define APPLANG "Fr"
  !define NAME "FramaStarter"
  !define FULLNAME "Framakey Starter"
  !define APP "Start"
  !define VER "0.2.2.2"
  !define COMPANY "Framakey"
  !define DEVELOP "sarkos and Tuxmouraille"
  !define DESCRIPTION "${FULLNAME} pour Windows XP"
  !define COMMENTS "${FULLNAME} (${APPLANG}) vous permet de lancer la suite logicielle ${COMPANY}."
  !define WEBSITE "http://www.framakey.org"

; Inclusion langue franaise (ajout de sarkos)
LoadLanguageFile "${NSISDIR}\Contrib\Language Files\French.nlf"

; Nom de l'excutable
  Name "${NAME} ${VER}"
; Etiquette
  Caption "${NAME} ${VER}"
; Icone
  Icon "framakey.ico"
  WindowIcon off

; Nom du fichier  crer
  OutFile "${APP}.exe"

; Runtime switches
  SetDateSave on
  SetDatablockOptimize on
  CRCCheck on
  SilentInstall silent
  AutoCloseWindow true

; -------------------------------------------
; Version Informations

  VIProductVersion "${VER}"
  VIAddVersionKey "ProductName" "${NAME}"
  VIAddVersionKey "CompanyName" "${COMPANY}"
  VIAddVersionKey "LegalTrademarks" "${NAME} by ${COMPANY}"
  VIAddVersionKey "LegalCopyright" "2005-2006 by ${DEVELOP} (GPL)"
  VIAddVersionKey "FileDescription" "${DESCRIPTION}"
  VIAddVersionKey "Comments" "${COMMENTS} Pour plus de dtails, visitez ${WEBSITE}."
  VIAddVersionKey "FileVersion" "${VER}"

; -------------------------------------------
; Variables

  Var DisableSplashScreen
  Var SplashScreenDir
  Var ExecuteProg
  Var WorkDir
  Var Parameter
  Var Cmd
  Var LaunchIt
  Var MessageToShow
  Var AskForIt
  Var n
  Var IniConfFile


; -------------------------------------------
; Macros
; Cette macro sert  ntoyer les chemins envoys en commande.
; Elle enlve tous les espaces et guillements: "  droite et  gauche du chemin.
!macro CleanPathCMD _pathcmd
	
	StrCpy $R0 `${_pathcmd}`
	
	; on va enlever tous les espaces et " au dbut du chemin
	StrCpy `$R1` `$R0` 1 ; on rcupre de premier carractre du chemin
	StrCmp `$R1` `"` +2 +1
	StrCmp `$R1` ` ` +1 +3
	StrCpy `$R0` `$R0` `` 1
	Goto -4

	; on va enlever tous les espaces et "  la fin
	StrCpy `$R1` `$R0` `` -1 ; on rcupre le dernier caractre du chemin
	StrCmp `$R1` `"` +2 +1
	StrCmp `$R1` ` ` +1 +3 ; si c'est un " +1 pour l'enlever si non +2
	StrCpy `$R0` `$R0` -1 ; le dernier carractre est un ", on l'enlve lechemin" devient lechemin
	Goto -4

	StrCpy "${_pathcmd}" $R0
	
!macroend

; -------------------------------------------
; Sections
Section "Main"
;== on rcupre d'ventuels paramtres envoys
   Call GetParameters
   Pop $Cmd
   StrCmp $Cmd `-close` +1 CloseProcess
   NotifyIcon::Icon /NOUNLOAD "iy" 103
   NotifyIcon::Icon /NOUNLOAD "n" "Framakey" "Fermeture de la Framakey!"
   ReadINIStr "$IniConfFile" "$EXEDIR\${APP}.ini" "ConfigurationFile" "path"
   WriteINIStr "$EXEDIR\${APP}.ini" "ConfigurationFile" "path" ""
   Sleep 1000
   Call CloseStarter
   Goto TheEnd
   
   CloseProcess:
   StrCpy `$R1` `$Cmd` 12
   StrCmp `$R1` `closeprocess` `` OtherConfigurationFile
   StrCpy `$R2` `$Cmd` "" 13
   !insertmacro CleanPathCMD `$R2` ; allez un petit ntoyage de paramtres
   Push `$R2`
   processwork::CloseProcess
   Goto TheEnd
   
   OtherConfigurationFile:
   StrCmp `$Cmd` `` "" ConfFileInCMD
   IfFileExists "$EXEDIR\${APP}.ini" "" startiniwasnotfound
   StrCpy `$IniConfFile` "$EXEDIR\${APP}.ini"
   Goto ReadForSplash
      
   startiniwasnotfound:
   MessageBox MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST "${APP}.ini est manquant.$\nVeulliez corrigez l'erreur ou utiliser un fichier de configuration secondaire."
   Abort

   ConfFileInCMD:
   StrCpy `$R2` `$Cmd`
   !insertmacro CleanPathCMD `$R2`
   StrCpy `$IniConfFile` `$R2`
   ; on va vrifier si le chemin n'est relatif
   StrCpy `$R0` `$IniConfFile` 2 1
	StrCmp `$R0` `:\` Verification FileConfRlvPath

	FileConfRlvPath:
	StrCpy `$IniConfFile` `$EXEDIR\$IniConfFile`

   Verification:
   ReadINIStr $0 `$IniConfFile` "SplashScreen" "SplashScreenDir"
   IfErrors ErrorParameter ReadForSplash

   ErrorParameter:
   MessageBox MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST `Si vous avez tent d'utiliser un fichier de configuration secondaire. \
   Ce fichier est incorrecte, veuillez le vrifier.$\nSa structure doit tre identique  ${APP}.ini.$\n$\n\
   Si vous avez tent de lancer Start avec une commande, celle ci est soit erron soit inconnue de Start.$\n\
   La commande que vous avez passer  Start est :$\n$Cmd`
   Abort
   
   ReadForSplash:
   WriteINIStr "$EXEDIR\${APP}.ini" "ConfigurationFile" "path" "$IniConfFile"
     
   ReadINIStr $DisableSplashScreen `$IniConfFile` "SplashScreen" "DisableSplashScreen"
   ReadINIStr $0 `$IniConfFile` "SplashScreen" "SplashScreenDir"
   StrCpy "$SplashScreenDir" "$EXEDIR\$0"
 
;== l je vous demande si vous voulez lancer les programmes supplmentaires.
        ReadINIStr "$ExecuteProg" `$IniConfFile` "Starter" "ExecuteProg1"
        StrCmp "$ExecuteProg" "" "" LauncheProg

        MessageBox MB_OK|MB_ICONSTOP|MB_TOPMOST "Erreur. Le nom du premier l'executable ne peut tre vide. Vrifier ${APP}.ini."
	Abort

   LauncheProg:   
   
   NotifyIcon::Icon /NOUNLOAD "iy" 103
   NotifyIcon::Icon /NOUNLOAD "n" "Framakey" "Lancement de la Framakey!"
   Sleep 2000
   
;== ici commence la boucle pour lancer les programmes supplmentaires.
        StrCpy $n 1
        BoucleProg:
   ReadINIStr "$ExecuteProg" "$IniConfFile" "Starter" "ExecuteProg$n"
	StrCmp "$ExecuteProg" "" LaunchMenu
   ReadINIStr "$LaunchIt" "$IniConfFile" "Starter" "LaunchIt$n"
        StrCmp "$LaunchIt" "true" "" LaunchItFalseCmd
   ReadINIStr "$AskForIt" "$IniConfFile" "Starter" "AskForIt$n"
	StrCmp "$AskForIt" "true" "" AskForItFalseCmd
   
   ReadINIStr "$MessageToShow" "$IniConfFile" "Starter" "MessageToShow$n"
   StrCmp "$MessageToShow" "" DefaultMessage PersonnalMessage
   
   
   LaunchItFalseCmd:
	StrCmp $LaunchIt "false" EndLaunchApp ""
	MessageBox MB_OK|MB_TOPMOST|MB_ICONSTOP `Paramtre incorrecte pour LaunchIt$n.$\n\
	Lisez les instructions dans ${APP}.ini et vrifiez le paramtre.`
	Abort

   AskForItFalseCmd:
   StrCmp $AskForIt "false" WorkingDir ""
   
   StrCmp $n "1" +3
   MessageBox MB_OK|MB_TOPMOST|MB_ICONSTOP `Paramtre incorrecte pour AskForIt $n.$\n\
   Lisez les instructions dans ${APP}.ini et vrifiez le paramtre.`
   Abort

   DefaultMessage:
   StrCpy "$4" "$ExecuteProg" -4
        MessageBox MB_YESNO|MB_TOPMOST|MB_ICONQUESTION `Voulez vous lancer $4?` IDYES WorkingDir IDNO EndLaunchApp
   
   PersonnalMessage:
   MessageBox MB_YESNO|MB_TOPMOST|MB_ICONQUESTION `$MessageToShow` IDYES WorkingDir IDNO EndLaunchApp
   
   WorkingDir:
 ReadINIStr "$WorkDir" `$IniConfFile` "Starter" "WorkDir$n"
        ReadINIStr "$Parameter" `$IniConfFile` "Starter" "Parameter$n"
	StrCpy `$R0` `$WorkDir` 2 1
	StrCmp `$R0` `:\` AbsolutePath RelativePath

	AbsolutePath:
	SetOutPath `$WorkDir` ;`$ExecuteString` `$WorkDir\$ExecuteProg`
	Goto IfExecuteProgExists
	
	RelativePath:
	SetOutPath `$EXEDIR\$WorkDir` ;`$ExecuteString` `$EXEDIR\$WorkDir\$ExecuteProg`
	Goto IfExecuteProgExists
	
   IfExecuteProgExists:
        IfFileExists "$ExecuteProg" LaunchProgram
		StrCpy "$5" "$ExecuteProg" -4
		MessageBox MB_OK|MB_ICONSTOP "Erreur. Le chemin d'accs pour $5 n'est pas valide. Vrifier ${APP}.ini."
		Abort
   
        LaunchProgram:
        StrCmp "$Parameter" "" "" LPWP
        Exec "$ExecuteProg"
        Goto EndLaunchApp
        LPWP:
        Exec `"$ExecuteProg" $Parameter`
   
        EndLaunchApp:
        IntOp $n $n + 1
        Goto BoucleProg
   
LaunchMenu:

   StrCmp "$DisableSplashScreen" "true" TheEnd
     newadvsplash::show /NOUNLOAD 2500 1000 500 -2 /BANNER "$SplashScreenDir"
     Sleep 2000 ;
     ;Pop $0 ; $0 has '1' if the user closed the splash screen early,
     ; '0' if everything closed normal, and '-1' if some error occured.

     TheEnd:
NotifyIcon::Icon "r"
SectionEnd

; ---------------------------------------
; la fonction de fermeture
Function CloseStarter

   StrCpy $R2 1
   BoucleCloseProcess:
   ReadINIStr $R3 "$IniConfFile" "Starter" "LaunchIt$R2"
   StrCmp $R3 "false" IncremBoucleCloseProcess
   ReadINIStr $R1 "$IniConfFile" "Starter" "ExecuteProgToStop$R2"
   StrCmp $R1 "" +1 +3
   ReadINIStr $R1 "$IniConfFile" "Starter" "ExecuteProg$R2"
   StrCmp $R1 "" FinBoucleCloseProcess
   
   processwork::CloseProcess `$R1`
   
   IncremBoucleCloseProcess:
   IntOp $R2 $R2 + 1
   Goto BoucleCloseProcess

   FinBoucleCloseProcess:

FunctionEnd

; GetParameters
 ; entre, aucune
 ; sortie, haut de la pile (remplacement, avec ex. toutca)
 ; ne modifie aucune autre variable.

 Function GetParameters
 
   Push $R0
   Push $R1
   Push $R2
   Push $R3
   
   StrCpy $R2 1
   StrLen $R3 $CMDLINE
   
   ;Check for quote or space
   StrCpy $R0 $CMDLINE $R2
   StrCmp $R0 '"' 0 +3
     StrCpy $R1 '"'
     Goto loop
   StrCpy $R1 " "
   
   loop:
     IntOp $R2 $R2 + 1
     StrCpy $R0 $CMDLINE 1 $R2
     StrCmp $R0 $R1 get
     StrCmp $R2 $R3 get
     Goto loop
   
   get:
     IntOp $R2 $R2 + 1
     StrCpy $R0 $CMDLINE 1 $R2
     StrCmp $R0 " " get
     StrCpy $R0 $CMDLINE "" $R2
   
   Pop $R3
   Pop $R2
   Pop $R1
   Exch $R0
 
 FunctionEnd
; -------------------------------------------
; Fin du script