; ----------------------------------------------------
; Framakey Installer : MainScript
; ----------------------------------------------------
; Written by sarkos
; License : GPL
; Copyright : 2005-2008 by Framasoft
; Ce script permet de fabriquer un excutable d'installation de la Framakey.
; Ce script est  compiler avec NSIS de Nullsoft (http://www.nullsoft.com).
; Il ncessite les plugins "newadvsplash" (affichage splashscreen) et Mutex
; pour tre compil.
; $id=FramakeyInstall.nsi $date=2007-09-30
; ----------------------------------------------------
; Gnral

;Niveau d'execution pour Windows Vista
RequestExecutionLevel user

; Dfinition variables entte
  !define NAME "Framakey"
  !define APP "FramakeyInstaller"
  !define VER "1.8.1.2"
  !define LANG "fr"
  !define PACK "Full"
  !define COMMENTS "Installer for Framakey"
  !define COMPANY "Framakey.org"
  !define DEVELOP "by Framakey Team"
  !define DESCRIPTION "Framakey Installer for Windows XP"
  !define WEBSITE "http://www.framakey.org"

; Nom de l'excutable
  Name "${NAME} ${VER} ${PACK}"
; Etiquette
  Caption "${NAME} ${VER} ${PACK}"
; Icone
  Icon "framakey.ico"
  WindowIcon off

; Nom du fichier  crer
  OutFile "..\${APP}_${PACK}-${VER}-${LANG}.exe"

; Runtime switches
  SetDateSave on
  SetDatablockOptimize on
  CRCCheck on
  SilentInstall normal
  ;BGGradient 000066 9999FF FF6633
  InstallColors FF8080 000030
  XPStyle on
  AutoCloseWindow false
  ShowInstDetails show
  AllowRootDirInstall true

; Rpertoire d'installation
  InstallDir "$INSTDIR"

; Inclusions Macros et Fonctions
  !include "FramakeyFunctions.nsh"

; ----------------------------------------------------
; Variables

  Var AppsDir
  Var DataDir
  ;Var ProfileDir

; ----------------------------------------------------
; Langues

  LoadLanguageFile "${NSISDIR}\Contrib\Language Files\French.nlf"

; ----------------------------------------------------
; Version Informations

  VIProductVersion "${VER}"
  VIAddVersionKey /LANG=${LANG_FRENCH} "ProductName" "${NAME}"
  VIAddVersionKey /LANG=${LANG_FRENCH} "Comments" "${COMMENTS}"
  VIAddVersionKey /LANG=${LANG_FRENCH} "CompanyName" "${COMPANY}"
  VIAddVersionKey /LANG=${LANG_FRENCH} "LegalTrademarks" "${NAME} ${DEVELOP}"
  VIAddVersionKey /LANG=${LANG_FRENCH} "LegalCopyright" "2005-2007 ${DEVELOP}"
  VIAddVersionKey /LANG=${LANG_FRENCH} "FileDescription" "${DESCRIPTION}"
  VIAddVersionKey /LANG=${LANG_FRENCH} "FileVersion" "${VER}"

; ----------------------------------------------------
; Pages

  Page license
  Page directory
  Page instfiles

; ----------------------------------------------------
; Texte de licence

  LicenseText "Merci de lire la licence suivante avant d'installer ${NAME}."
  LicenseData "..\Framakey\Licence-fr.txt"
  LicenseForceSelection checkbox "J'accepte les termes de la licence"

; ----------------------------------------------------
; Texte de choix du rpertoire de destination

  DirText 'Destination de l$\'installation de ${NAME}. Utilisez "Parcourir" pour trouver le chemin de votre cl USB.$\n Trs important :$\n Pensez  faire une sauvegarde de vos profils et documents personnels$\n si vous utilisiez une version antrieure.'

; ----------------------------------------------------
; Sections

Section "Main"
  SetOutPath "$INSTDIR"

; Vrification de l'existence d'une ancienne version Framakey
  IfFileExists "$INSTDIR\programs" "" CheckAppsDir2
    StrCpy "$AppsDir" "$INSTDIR\programs"
    StrCpy "$DataDir" "$INSTDIR\mes_donnees"
    Goto DeleteOldFiles

  CheckAppsDir2:
  IfFileExists "$INSTDIR\Apps" "" CopyFiles
    StrCpy "$AppsDir" "$INSTDIR\Apps"
    StrCpy "$DataDir" "$INSTDIR\Data"

; Nettoyage de la cl
  DeleteOldFiles:
  RmDir /r "$AppsDir\PortableCoolplayer"
  RmDir /r "$AppsDir\PortableFirefox"
  RmDir /r "$AppsDir\PortableOpenOffice"
  RmDir /r "$AppsDir\PortablePidgin"
  RmDir /r "$AppsDir\PortableSciTE"
  RmDir /r "$AppsDir\PortableThunderbird"
  RmDir /r "$AppsDir\PortableVLC"
  RmDir /r "$INSTDIR\framakey"
  RmDir /r "$INSTDIR\src"

; Copie contenu Framakey
  CopyFiles:
  File /r "..\Apps"
  File /r "..\Data"
  File /r "..\Framakey"
  File /r "..\src"
  File "..\start.exe"
  File "..\start.ini"
  File "..\autorun.inf"

SectionEnd

Section -PostInstall
  File "..\Framakey\Licence-fr.txt"

; Effacement du rpertoire temporaire (plus utilis pour le moment)
;  RmDir /r "$TempDir"
SectionEnd

; ----------------------------------------------------
; Fonctions gnrales

Function .onInit
  Call Mutex
  # the plugins dir is automatically deleted when the installer exits
  InitPluginsDir
  !insertmacro SplashInit "splash.jpg" ""
  MessageBox MB_YESNO|MB_ICONQUESTION ' La suite logicielle ${NAME} "${PACK}" va tre installe.$\n$\n Mise en garde : l$\'installation de la Framakey sur cl USB$\n peut prendre PLUSIEURS HEURES (suivant la qualit de la cl) !$\n $\n  Continuer ?' IDYES NoAbort
  Abort ; causes uninstaller to quit.
  NoAbort:
FunctionEnd

Function .onUserAbort
  MessageBox MB_YESNO|MB_ICONQUESTION "Voulez-vous abandonner l'installation ?" IDYES NoCancelAbort
  Abort ; causes uninstaller to not quit.
  NoCancelAbort:
FunctionEnd

Function .onInstFailed
  MessageBox MB_OK "Installation incomplte."
FunctionEnd

Function .onInstSuccess
  MessageBox MB_YESNO|MB_ICONQUESTION 'Votre FramaKey est maintenant installe dans le dossier$\n "$INSTDIR".$\n Voulez-vous lancer "start.exe" ?' IDNO NoStart
  Exec "$INSTDIR\start.exe"
  NoStart:
FunctionEnd

; ----------------------------------------------------
; Fin du script
